ALFA 2.0 - the Abbreviated Language for Authorization
Internet-Draft draft-brossard-alfa-authz-00
David Brossard
Axiomatics
Canada
david.brossard@gmail.com
Andrew Clymer
Rock Solid Knowledge
United Kingdom
andy@rocksolidknowledge.com
Theodosios Dimitrakos
University of Kent School of Computing
t.dimitrakos@kent.ac.uk
22 July 2024
Security
Web Authorization Protocol
authorization
abac
rebac
rbac
access control
xacml
policy language
The Abbreviated Language for Authorization 2.0 is a constrained policy language aimed at solving fine-grained authorization challenges. This specification builds on top of [XACML] and replaces [ALFA] to provide a more complete and easier language to use.
Use cases for ALFA 2.0 include the ability to express: - Role-based access control ([RBAC]), - Attribute-based access control ([ABAC]), and - Relationship-based access control ([ReBAC])
About This Document
The latest revision of this draft can be found at https://davidjbrossard.github.io/alfa-authorization-language/draft-brossard-alfa-authz.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-brossard-alfa-authz/.
Discussion of this document takes place on the Web Authorization Protocol Working Group mailing list (mailto:oauth@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/oauth/. Subscribe at https://www.ietf.org/mailman/listinfo/oauth/.
Source for this draft and an issue tracker can be found at https://github.com/davidjbrossard/alfa-authorization-language.
Introduction
While authentication has largely been solved and standardized (see [OAUTH] and SAML as successful authentication standards), not as much can be said of authorization. One of the oldest and more mature standards is [XACML], the eXtensible Access Control Markup Language established in 2001 under the helm of OASIS. The latest version, XACML 3.0, was released in 2013.
Since, there has been little innovation in the authorization space. Two standards emerged:
- ALFA: Abbreviated Language for Authorization (ALFA) is a domain-specific language for a high-level description of XACML policies. It is designed with ease of use in mind, for use by XACML policy writers. ALFA provides the means to present domain specific information, such as attribute identifiers, in compact form and lays down the basic principle to compile policies expressed in ALFA into XACML 3.0 policies. ALFA does not bring new semantics to XACML. Anything that can be expressed in ALFA must be expressible in XACML. ALFA has been designed in such a way that lossless round-trip translations is possible.
- OPA: Open Policy Agent is an open source, general-purpose policy engine that unifies policy enforcement across the stack. OPA provides a high-level declarative language that lets you specify policy as code and simple APIs to offload policy decision-making from your software. [OPA]
While OPA became part of CNCF, ALFA remained as a draft under OASIS. OPA's strength is also its drawback. It's a fullblown Datalog-based programming language which can achieve anything: it's extremely broad. As for ALFA, as mentioned above, it's true to XACML and aims to achieve lossless round-trip translations leading to unnecessary complications in ALFA's existing grammar.
The aim of this standard is to provide a simple and constrained authorization language largely inspired by ALFA but not tied to XACML and not limited by the need to provide round-tripping.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Security Considerations
TODO Security
IANA Considerations
This document has no IANA actions.
References
Normative References
[XACML]

eXtensible Access Control Markup Language (XACML) Version 3.0, OASIS Standard
Erik Rissanen
Axiomatics AB
January 2013
[ABAC]

Guide to Attribute Based Access Control (ABAC) Definition and Considerations - NIST Special Publication 800-162
Vincent Hu
NIST
David Ferraiolo
NIST
January 2014
[ALFA]

Abbreviated Language for Authorization Version 1.0
Pablo Giambiagi
Axiomatics
Srijith K. Nair
Axiomatics
David Brossard
Axiomatics
March 2015
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[OAUTH]

The OAuth 2.0 Authorization Framework
D. Hardt, Ed.
October 2012
RFC 6749
DOI 10.17487/RFC6749
[RBAC]

The NIST Model for Role-Based Access Control: Towards a Unified Standard
D. Richard Kuhn
NIST
David Ferraiolo
NIST
R. Sandhu
NIST
July 2000
[ReBAC]

Access Control Requirements for Web 2.0 Security and Privacy
Carrie Gates
CA Technologies
January 2007
[OPA]

Open Policy Agent | Documentation
Styra
Styra
July 2024
Acknowledgments
The authors would like to acknowledge the authors of the original version of ALFA namely Pablo Giambiagi and Dr. Srijith Nair. The authors would also like to acknowledge Erik Rissanen, the then editor of the XACML Technical Committee.